d("headerView",['ccrz', 'util'], function(CCRZ, UTIL) {
    return {
        extendHeaderView: function() {
            let isMenuRefresh = false;
            CCRZ.pubSub.on('view:Menu:refresh', function(menuView){
                if(!isMenuRefresh){
                    menuView.events['click .cc_goto_login'] = 'openLoginModal';
                    menuView.openLoginModal = function() {
                        if(CCRZ.pagevars.currentPageName !== 'ccrz__CCForgotPassword'){
                            $('#loginModal').modal({backdrop: true, show: true}); 
                            $('#loginModal').removeClass('fade');
                            $('.modal-backdrop').removeClass('fade');
                        }
                    };
                    CCRZ.remoteModel.getMenu(JSON.stringify({}), function(res, event){
                        if(res && res.success && res.data){
                            CCRZ.data.menus = JSON.parse(res.data);
                            menuView.render();
                        } else {
                            //Error Handling
                        }
                        isMenuRefresh = true;
                    });
                    menuView.cartHeaderView = new CCRZ.views.cartHeaderView();
                }
            });
            CCRZ.pubSub.once('view:EffAccountSelView:refresh', function(effAccountView){
                effAccountView.events['click .invokeEffModal'] = 'invokeEffectiveAccountModal';
                effAccountView.invokeEffectiveAccountModal = function(){
                    $('#effAccounts').modal({backdrop: true, show: true}); 
                    $('#effAccounts').removeClass('fade');
                    $('.modal-backdrop').removeClass('fade');
                };
                effAccountView.pickAccount = function(event) {
                    var v = this;
                    var selAccId = $(event.currentTarget).data("id");
                    UTIL.showLoader();
                    v.processSelection(selAccId);
                };
                effAccountView.processSelection = function(selAccId) {
                    var v = this;
                    var selAcc = this.accounts.get(selAccId);
                    if (selAcc) {
                    sessionStorage.setItem('retURL', window.location.href);
                    sessionStorage.setItem('isEffectiveInit', true);
                     $('#effAccounts').toggle('close');
                     CCRZ.console.log(selAcc);
                     CCRZ.pagevars.remoteContext.effAccountId = selAcc.get('sfid');
                     v.invokeCtx('selectEffectiveAccount', selAcc.toJSON(), v.miscData, function(response) {
                      CCRZ.console.log(response);
                      if (response && response.success) {
                       CCRZ.pagevars.effAccountId = response.data.workingEffAccount.sfid;
                       CCRZ.setCookie('apex__effacc', response.data.workingEffAccount.sfid, 50);
                       CCRZ.pagevars.remoteContext.effAccountId = response.data.workingEffAccount.sfid;
                       CCRZ.pagevars.remoteContext.queryParams.effectiveAccount = response.data.workingEffAccount.sfid;
                       if (response.data.cartBean) {
                        CCRZ.pagevars.currentCartID = response.data.cartBean.encryptedId;
                        CCRZ.pubSub.trigger('cartChange', CCRZ.pagevars.currentCartID);
                       }
                       v.dataSet.workingEffAccount = selAcc.attributes;
                       $('.modal-backdrop').addClass('fade');
                       //v.postProcessSelection();
                       v.render();
                       let currentURL = window.location.href, urlList = currentURL.split('?'), newURL = '';
                       newURL = urlList[0];
                       if(urlList.length > 1){
                        newURL += '?';
                        for(let key in CCRZ.pagevars.remoteContext.queryParams){
                            newURL += key + '=' + CCRZ.pagevars.remoteContext.queryParams[key] + '&';
                        }
                        newURL = newURL.substring(0, newURL.length - 1);
                       }
                       window.history.pushState({}, null, newURL);
                       window.setTimeout(function(){
                        window.location.reload();
                       }, 200);
                      } else {
                        UTIL.hideLoader();
                      }
                     });
                    } else {
                        UTIL.hideLoader();
                    }
                };
                effAccountView.delegateEvents();
                /*var existingSelAcc = CCRZ.getCookie('apex__effacc');
                if (!CCRZ.pagevars.effAccountId && existingSelAcc){
                    CCRZ.pagevars.effAccountId = existingSelAcc;
                }*/
                effAccountView.render();
            });
            CCRZ.pubSub.once('view:headerView:refresh', function(headerView){
                $('#dismiss').on('click', function () {
                    $('#sidebar').removeClass('active');
                    $('#sidebarBackdrop').addClass('hide');
                });
                headerView.events['click #cartDrop'] = 'renderMiniCart';
                headerView.events['click .toggle-btn-top'] = 'toggleTopMenu';
                headerView.events['click .searchBtn'] = 'handleSearch';
                headerView.events['keypress #searchTextKF'] = 'handleSearchInput';
                headerView.events['click #sidebarBackdrop'] = 'closeMiniCart';
                headerView.events['click .cc_goto_login'] = 'openLoginModal';
                headerView.openLoginModal = function() {
                    $('#loginModal').modal({backdrop: true, show: true}); 
                    $('#loginModal').removeClass('fade');
                    $('.modal-backdrop').removeClass('fade');
                };
                headerView.closeMiniCart = function() {
                    $('#sidebar').removeClass('active');
                    $('#sidebarBackdrop').addClass('hide');
                };
                headerView.handleSearchInput = function(event){
                    let char = String.fromCharCode(event.which || event.keyCode);
                    if(!UTIL.isAlphaNumeric(char) && (event.which != 13) && char != " "){
                        return false;
                    }
                    let value = event.target.value + char;
                    if ((event.keyCode == 13 || event.which == 13) && value.length > 2) {
                        event.preventDefault();
                        headerView.handleSearch(event);
                        return false;
                    } else {
                        return true;
                    }
                };
                headerView.handleSearch = function(event){
                    let value = $('#searchTextKF').val();
                    if(value.length > 2){
                        window.open(UTIL.getNavigateURL('plp', {'searchText': value.trim(), 'cartID': CCRZ.pagevars.currentCartID.trim()}), '_self');
                    }
                };
                headerView.toggleTopMenu = function(event){
                    let x = document.getElementById("top-header-links");
                    if (x.className === "top-header-links") {
                        x.className += " responsive";
                    } else {
                        x.className = "top-header-links";
                    }
                };
                headerView.renderMiniCart = function(event){
                    if(CCRZ.pagevars.currentPageName == 'ccrz__OrderConfirmation' || CCRZ.pagevars.currentPageName == 'ccrz__Cart'){
                        return false;
                    } else if(CCRZ.pagevars.currentPageName == 'ccrz__CheckoutNew' || CCRZ.pagevars.currentPageName == 'ccrz__SubscriptionDetail'
                    || CCRZ.pagevars.currentPageName == 'ccrz__StoredPaymentDetail' || CCRZ.pagevars.currentPageName == 'ccrz__OrderView'
                    || CCRZ.pagevars.currentPageName == 'ccrz__InvoiceDetail' || CCRZ.pagevars.currentPageName == 'ccrz__InvoicePayment'
                    || CCRZ.pagevars.currentPageName == 'ccrz__CCPage'){
                        headerView.goToCart();
                    } else {
                        $('#sidebar').addClass('active'); 
                        $('.sidebarMiniCart').removeClass('hide');
                        $('#sidebarBackdrop').removeClass('hide');
                    }
                };
                headerView.postRender = function(){
                    if(!_.isUndefined(CCRZ.pagevars.queryParams.isNewUser) && CCRZ.pagevars.queryParams.isNewUser){
                        $('#welcomeModal').modal({backdrop: true, show: true}); 
                        $('#welcomeModal').removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    }
                };
                headerView.delegateEvents();
                /*let retURL = sessionStorage.getItem('retURL', window.location.href), isEffective = sessionStorage.getItem('isEffectiveInit', true);
                if(!_.isUndefined(retURL) && !_.isUndefined(isEffective) && isEffective == 'true'){
                    sessionStorage.setItem('isEffectiveInit', false);
                    UTIL.showLoader();
                    window.open(retURL, '_self');
                }*/
            });
        }
    }
});